/*
 * Copyright (C) 2016 Red Hat, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.syndesis.server.openshift.crd;

import java.io.Serializable;
import java.util.Objects;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;

@JsonIgnoreProperties(ignoreUnknown = true)
public class SyndesisSpec implements Serializable {

    private final IntegrationScheduling integrationScheduling;

    @JsonCreator
    public SyndesisSpec(@JsonProperty("integrationScheduling") final IntegrationScheduling integrationScheduling) {
        this.integrationScheduling = integrationScheduling;
    }

    public IntegrationScheduling getIntegrationScheduling() {
        return integrationScheduling;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof SyndesisSpec)) {
            return false;
        }
        SyndesisSpec that = (SyndesisSpec) o;
        return Objects.equals(integrationScheduling, that.integrationScheduling);
    }

    @Override
    public int hashCode() {
        return Objects.hash(integrationScheduling);
    }

    @Override
    public String toString() {
        return "Spec{" +
            "integrationScheduling=" + integrationScheduling +
            '}';
    }
}
